﻿
Public Class Form1

    Private oldVertical As Boolean
    Private oldzoom As Double

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        '
        Text = AppTitleAndVersion(True)
        ToolTips_Init()
        '
        Load_INI()
        LoadSlotNames()
        EnableDisableControls()
        oldVertical = chk_Vertical.Checked
        oldzoom = txt_Zoom.NumericValue
        InitParams()
        ' ----------------------------------------------------------------
        Timer1.Interval = 15
        Timer1.Start()
        EventsAreEnabled = True
        ' ---------------------------------------------------------------- start UserInterface
        TestMousePosition()
        PinnedImage_ShowHide()
        Refresh()
        Me.Opacity = 1
        PanelDummy.Focus()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        Timer1.Stop()
        Save_INI()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
        Save_INI()
    End Sub

    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        If Not EventsAreEnabled Then Return
        If Me.WindowState = FormWindowState.Minimized Then Return
        ' ----------------------------------------------------------------------------------------------
        ' This is a patch because the SizeChanged event sometimes is called without an effective change
        ' ----------------------------------------------------------------------------------------------
        Static oldsize As Size = New Size(0, 0)
        If Me.Size <> oldsize Then
            InitParams()
            Save_INI()
            oldsize = Me.Size
        End If
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        If Me.WindowState = FormWindowState.Minimized Then
            Timer1.Stop()
            Return
        Else
            Timer1.Start()
        End If
        ' ----------------------------------------------------------------------------------------
        ' This is a patch because the Resize event sometimes is called without an effective change
        ' ----------------------------------------------------------------------------------------
        Static oldsize As Size = New Size(0, 0)
        If Me.Size <> oldsize Then
            InitParams()
            Save_INI()
            oldsize = Me.Size
        End If
    End Sub



    ' ====================================================================================================
    '  Params
    ' ====================================================================================================
    Private FirstSlot As Int32
    Private NumSlots As Int32
    Private MaxValue As Int32
    Private MinValue As Int32
    Friend Colors As Int32
    Private Vertical As Boolean
    Private Decimals As Int32
    Private RepeatDelay As Int32
    Private RepeatTime As Int32
    Private ClickEnabled As Boolean
    Private Sub Params_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                            Handles txt_FirstSlot.LostFocus, _
                                                                    txt_NumSlots.LostFocus, _
                                                                    txt_MaxValue.LostFocus, _
                                                                    txt_MinValue.LostFocus, _
                                                                    txt_Decimals.LostFocus, _
                                                                    txt_Zoom.LostFocus, _
                                                                    chk_Vertical.LostFocus, _
                                                                    chk_Selective.LostFocus, _
                                                                    chk_Locked.LostFocus
        Save_INI()
    End Sub
    Private Sub txt_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                            Handles txt_FirstSlot.TextChanged, _
                                                                    txt_NumSlots.TextChanged, _
                                                                    txt_MaxValue.TextChanged, _
                                                                    txt_MinValue.TextChanged, _
                                                                    txt_Decimals.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        InitParams()
    End Sub

    Private Sub txt_Zoom_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                    Handles txt_Zoom.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        If Vertical Then
            Me.Height = CInt(Me.Height * (txt_Zoom.NumericValue + 21) / (oldzoom + 21))
        Else
            Me.Width = CInt(Me.Width * (txt_Zoom.NumericValue + 24) / (oldzoom + 24))
        End If
        oldzoom = txt_Zoom.NumericValue
        InitParams()
        Save_INI()
    End Sub

    Private Sub chk_Colors_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                            Handles chk_Colors.CheckedChanged
        Colors += 1
        If Colors > 2 Then Colors = 0
        InitParams()
        Save_INI()
        chk_Colors.Checked = False
    End Sub
    Private Sub chk_Vertical_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) _
                                                            Handles chk_Vertical.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        SuspendRedraw(Me)
        InitParams()
        SlotBars_Show()
        ResumeRedraw(Me)
        Save_INI()
    End Sub
    Private Sub chk_EditSlotNames_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                             Handles chk_EditSlotFile.CheckedChanged
        Me.Opacity = 0.7
        Dim fname As String = Application.StartupPath & "\SlotNames.txt"
        If Not My.Computer.FileSystem.FileExists(fname) Then IO.File.Create(fname)
        ProcessStartAndWait(fname)
        chk_EditSlotFile.Checked = False
        Me.Opacity = 1
        SlotBars_Show()
    End Sub
    Private Sub chk_Selective_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                             Handles chk_Selective.CheckedChanged
        SuspendRedraw(Me)
        SlotBarsArray_Clear()
        InitParams()
        ResumeRedraw(Me)
    End Sub

    Private Sub InitParams()
        ' -------------------------------------------------------------------------
        SlotBarsWidth = 22 + txt_Zoom.NumericValueInteger - 10
        ' ------------------------------------------------------------------------- set params
        UnselectAllSlotBars()
        FirstSlot = txt_FirstSlot.NumericValueInteger
        NumSlots = txt_NumSlots.NumericValueInteger
        txt_FirstSlot.MaxValue = 1000 - NumSlots
        txt_NumSlots.MaxValue = Math.Min(1000 - FirstSlot, 100)
        ' -------------------------------------------------------------------------
        MaxValue = txt_MaxValue.NumericValueInteger
        MinValue = txt_MinValue.NumericValueInteger
        Vertical = chk_Vertical.Checked
        Decimals = txt_Decimals.NumericValueInteger
        ' ------------------------------------------------------------------------- show
        SlotBars_Show()
        EventsAreEnabled = False
        Dim oldW As Int32 = Me.Size.Width
        Dim oldH As Int32 = Me.Size.Height
        Dim nbars As Int32 = NumSlots
        If NumVisibleBars > 0 Then nbars = NumVisibleBars
        ' ------------------------------------------------------------------------- if not minimized then set limits
        If Me.WindowState = FormWindowState.Normal Then
            ' --------------------------------------------------------------------- allow any resize
            Dim MinWidth As Int32 = Panel_Controls.Right + 20
            If Panel_Controls.Visible Then MinWidth += 220
            Dim MinHeight As Int32 = Panel_Controls.Bottom + SystemInformation.CaptionHeight + 20
            Me.MaximumSize = New Size(9000, 9000)
            Me.MinimumSize = New Size(MinWidth, MinHeight)
            ' --------------------------------------------------------------------- resize and limit the form
            If Vertical Then
                If Vertical <> oldVertical Then
                    Me.Height = oldW - Panel_Controls.Right + 16
                End If
                Me.ClientSize = New Size(Panel_Controls.Right + 4 + nbars * SlotBarsWidth, Me.ClientSize.Height)
                Me.MaximumSize = New Size(Me.Size.Width, 9000)
                Me.MinimumSize = New Size(Me.Size.Width, MinHeight)
            Else
                If Vertical <> oldVertical Then
                    Me.Width = oldH + Panel_Controls.Right - 16
                End If
                Me.ClientSize = New Size(Me.ClientSize.Width, 9 + nbars * SlotBarsWidth)
                Me.MaximumSize = New Size(9000, Me.Size.Height)
                Me.MinimumSize = New Size(MinWidth + 2, Me.Size.Height)
            End If
            oldVertical = Vertical
        End If
        EventsAreEnabled = True
        ' -------------------------------------------------------------------------- to overcome Linux position error
        If Not OperatingSystemIsWindows Then Panel_Controls.Left = -2
        PanelDummy.SendToBack()
    End Sub

    ' ====================================================================================================
    '  Timer
    ' ====================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        PollSlots()
        TestSlotFile()
    End Sub
    Private Sub PollSlots()
        For i As Int32 = 0 To SlotBars.Length - 1
            If SlotBars(i) Is Nothing Then Continue For
            SlotBars(i).SetValue(Slots.ReadSlot(SlotBars(i).GetSlotIndex))
        Next
        TestMousePosition()
    End Sub

    Private Sub TestMousePosition()
        Static old As Boolean = True
        Dim MouseInside As Boolean = New Rectangle(Me.Location, Me.Size).Contains(Cursor.Position)
        If MouseInside <> old Then
            old = MouseInside
            With Panel_Controls
                If MouseInside Then
                    If Not .Visible Then
                        .Visible = True
                        .Location = New Point(4, 2)
                        InitParams()
                        SlotBars_Show()
                    End If
                Else
                    If Not chk_Pinned.Checked Then
                        .Visible = False
                        .Location = New Point(4 - .Width, 2 - .Height)
                        InitParams()
                        SlotBars_Show()
                    End If
                End If
            End With
        End If
    End Sub

    Private Sub chk_Pinned_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                                           Handles chk_Pinned.CheckedChanged
        PinnedImage_ShowHide()
    End Sub

    Private Sub PinnedImage_ShowHide()
        If chk_Pinned.Checked Then
            chk_Pinned.Image = My.Resources.Pin
        Else
            chk_Pinned.Image = My.Resources.Pin_Grey
        End If
    End Sub

    ' ====================================================================================================
    '  ArrowUp / ArrowDown / Pageup / PageDown and MouseWheel 
    ' ====================================================================================================
    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If Locked Then Return
        Dim n As Single
        Select Case e.KeyCode
            Case Keys.Up : If Vertical Then n = 1 Else ChangeSelectedSlotBar(-1)
            Case Keys.Down : If Vertical Then n = -1 Else ChangeSelectedSlotBar(1)
            Case Keys.Right : If Vertical Then ChangeSelectedSlotBar(1) Else n = 1
            Case Keys.Left : If Vertical Then ChangeSelectedSlotBar(-1) Else n = -1
            Case Keys.PageUp : n = 10
            Case Keys.PageDown : n = -10
            Case Keys.Escape : UnselectAllSlotBars()
        End Select
        If e.Shift Then n *= 100
        If e.Control Then n *= 10
        If e.Alt Then n /= 10
        If SelectedSlotBar IsNot Nothing Then SelectedSlotBar.DeltaValue(n)
    End Sub
    Private Sub Form1_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseWheel
        If Locked Then Return
        Dim n As Single = CInt(e.Delta / 1.2)
        If SelectedSlotBar IsNot Nothing Then SelectedSlotBar.DeltaValue(n)
    End Sub

    Private SelectedSlotBar As SlotBar
    Friend Sub SetSelectedSlotBar(ByRef slotbar As SlotBar)
        If Locked Then Return
        '
        If SelectedSlotBar IsNot Nothing Then
            SelectedSlotBar.Selected = False
            SelectedSlotBar.ShowValue()
        End If
        SelectedSlotBar = slotbar
        SelectedSlotBar.Selected = True
        SelectedSlotBar.ShowValue()
        '
        PanelDummy.Focus()
    End Sub

    Private Sub ChangeSelectedSlotBar(ByRef delta As Int32)
        If SelectedSlotBar Is Nothing Then Return
        Dim index As Int32
        index = GetSlotBarArrayIndex(SelectedSlotBar)
        index += delta
        If index >= 0 And index <= SlotBars.Length - 1 Then
            SetSelectedSlotBar(SlotBars(index))
        End If
    End Sub

    Private Sub UnselectAllSlotBars()
        For i As Int32 = 0 To SlotBars.Length - 1
            SlotBars(i).Selected = False
        Next
    End Sub

    Private Function GetSlotBarArrayIndex(ByVal sb As SlotBar) As Int32
        For i As Int32 = 0 To SlotBars.Length - 1
            If sb Is SlotBars(i) Then
                Return i
            End If
        Next
    End Function


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 700
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_FirstSlot, _
                        " First slot" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The index of the first slot." & vbCrLf & vbCrLf & _
                        " Press the left mouse button and move mouse Up and Down" & vbCrLf & _
                        " or use the mouse wheel to trim this value.")

        ttp1.SetToolTip(txt_NumSlots, _
                        " Number of slots" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The number of the consecutive slots." & vbCrLf & vbCrLf & _
                        " Press the left mouse button and move mouse Up and Down" & vbCrLf & _
                        " or use the mouse wheel to trim this value.")

    End Sub
    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub controls_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles txt_FirstSlot.MouseEnter, _
                                                                        txt_NumSlots.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub


    ' ==============================================================================================================
    '   LOCKED / UNLOCKED
    ' ==============================================================================================================
    Private Locked As Boolean = False
    Private Sub EnableDisableControls()
        Locked = chk_Locked.Checked
        txt_FirstSlot.Enabled = Not Locked
        txt_NumSlots.Enabled = Not Locked
        txt_MaxValue.Enabled = Not Locked
        txt_MinValue.Enabled = Not Locked
        txt_Decimals.Enabled = Not Locked
        chk_Pinned.Enabled = Not Locked
        txt_Zoom.Enabled = Not Locked
        chk_Colors.Enabled = Not Locked
        chk_Vertical.Enabled = Not Locked
        chk_EditSlotFile.Enabled = Not Locked
        chk_Selective.Enabled = Not Locked
        If Locked Then
            BackColor = Color.FromArgb(210, 255, 210)
        Else
            BackColor = Color.LightYellow
        End If
    End Sub

    Private Sub chk_Locked_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) _
                                                                   Handles chk_Locked.CheckedChanged
        EnableDisableControls()
        ' --------------------------------------------------------------------- show
        SlotBars_Show()
        PanelDummy.SendToBack()
    End Sub


    ' ====================================================================================================
    '  SlotBars
    ' ====================================================================================================
    Private SlotBarsWidth As Int32 = 22 - 4
    Private SlotBars(-1) As SlotBar

    Private Sub SlotBarsArray_Clear()
        For i As Int32 = 0 To SlotBars.Length - 1
            If SlotBars(i) IsNot Nothing Then SlotBars(i).Destroy()
        Next
        ReDim SlotBars(-1)
    End Sub

    Friend Sub SlotBars_Show()
        ' ------------------------------------------------------------ load slot names
        LoadSlotNames()
        ' ------------------------------------------------------------ select type
        If chk_Selective.Checked And ValidSlotNames Then
            SlotBars_ShowPartial()
        Else
            SlotBars_ShowTotal()
            chk_Selective.Checked = False
        End If
    End Sub

    Private Sub SlotBars_ShowTotal()
        ' ------------------------------------------------------------ 
        SuspendRedraw(Me)
        ' ------------------------------------------------------------ add remove bars
        If SlotBars Is Nothing OrElse NumSlots > SlotBars.Length Then
            Dim oldlen As Int32 = SlotBars.Length
            ReDim Preserve SlotBars(NumSlots - 1)
            For i As Int32 = oldlen To SlotBars.Length - 1
                SlotBars(i) = New SlotBar(Me)
            Next
        ElseIf NumSlots < SlotBars.Length Then
            For i As Int32 = NumSlots To SlotBars.Length - 1
                SlotBars(i).Destroy()
            Next
            ReDim Preserve SlotBars(NumSlots - 1)
        End If
        ' ------------------------------------------------------------ prepare params
        Dim barsLeft As Int32 = Panel_Controls.Right
        NumVisibleBars = 0
        For i As Int32 = 0 To SlotBars.Length - 1
            If SlotBars(i) Is Nothing Then Continue For

            Dim opt As SlotNamesOptions = ExtractSlotNamesOptions(FirstSlot + i, MinValue, MaxValue)

            SlotBars(i).SetLockedStatus(Locked)
            SlotBars(i).SetSlotIndex(FirstSlot + i)
            SlotBars(i).SetText(opt.Text)
            If Vertical Then
                SlotBars(i).SetAspectParams(barsLeft + i * SlotBarsWidth, 5, _
                                            SlotBarsWidth, _
                                            Me.ClientSize.Height - 9, _
                                            True, _
                                            opt.Max, _
                                            opt.Min, _
                                            Colors, Decimals)
            Else
                SlotBars(i).SetAspectParams(barsLeft, 5 + i * SlotBarsWidth, _
                                            Me.ClientSize.Width - barsLeft - 4, _
                                            SlotBarsWidth, _
                                            False, _
                                            opt.Max, _
                                            opt.Min, _
                                            Colors, Decimals)
            End If
        Next
        ' ------------------------------------------------------------ draw bars
        For i As Int32 = 0 To SlotBars.Length - 1
            If SlotBars(i) Is Nothing Then Continue For
            SlotBars(i).ShowValue()
        Next
        ' ------------------------------------------------------------ 
        PanelDummy.SendToBack()
        PollSlots()
        ResumeRedraw(Me)
        Refresh()
    End Sub

    Private NumVisibleBars As Int32

    Private Sub SlotBars_ShowPartial()
        ' ------------------------------------------------------------ 
        SuspendRedraw(Me)
        ' ------------------------------------------------------------ clear bars
        SlotBarsArray_Clear()
        ReDim SlotBars(NumSlots - 1)
        ' ------------------------------------------------------------ prepare params
        Dim barsLeft As Int32 = Panel_Controls.Right
        NumVisibleBars = 0

        For i As Int32 = FirstSlot To 999
            '
            If i < SlotNames.Length Then ' AndAlso SlotNames(i) IsNot Nothing Then
                '
                Dim opt As SlotNamesOptions = ExtractSlotNamesOptions(i, MinValue, MaxValue)
                If Not opt.Visible Then Continue For
                '
                SlotBars(NumVisibleBars) = New SlotBar(Me)
                SlotBars(NumVisibleBars).SetLockedStatus(Locked)
                SlotBars(NumVisibleBars).SetSlotIndex(i)
                SlotBars(NumVisibleBars).SetText(opt.Text)
                If Vertical Then
                    SlotBars(NumVisibleBars).SetAspectParams(barsLeft + NumVisibleBars * SlotBarsWidth, 5, _
                                                SlotBarsWidth, _
                                                Me.ClientSize.Height - 9, _
                                                True, _
                                                opt.Max, _
                                                opt.Min, _
                                                Colors, Decimals)
                Else
                    SlotBars(NumVisibleBars).SetAspectParams(barsLeft, 5 + NumVisibleBars * SlotBarsWidth, _
                                                Me.ClientSize.Width - barsLeft - 4, _
                                                SlotBarsWidth, _
                                                False, _
                                                opt.Max, _
                                                opt.Min, _
                                                Colors, Decimals)
                End If
                '
                NumVisibleBars += 1
                If NumVisibleBars >= NumSlots Then Exit For
            End If
            '
        Next
        ' ------------------------------------------------------------ draw bars
        For i As Int32 = 0 To SlotBars.Length - 1
            If SlotBars(i) Is Nothing Then Continue For
            SlotBars(i).ShowValue()
        Next
        ' ------------------------------------------------------------ 
        PanelDummy.SendToBack()
        PollSlots()
        ResumeRedraw(Me)
        Refresh()
    End Sub

End Class